// Generated by CoffeeScript 1.12.6
(function() {
  var Benchmark, colors, global_ids, now,
    bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; };

  global_ids = null;

  colors = require('colors');

  now = require('performance-now');

  Benchmark = (function() {
    function Benchmark(options) {
      var label;
      if (options == null) {
        options = {};
      }
      this.prettyPrint = bind(this.prettyPrint, this);
      this.print = bind(this.print, this);
      this.toString = bind(this.toString, this);
      this.elapsed = bind(this.elapsed, this);
      label = options.label;
      if (global_ids[label] == null) {
        global_ids[label] = 0;
      }
      global_ids[label] += 1;
      this.id = label + "-" + global_ids[label];
      this.startTime = now();
    }

    Benchmark.prototype.elapsed = function() {
      return Math.round(now() - this.startTime);
    };

    Benchmark.prototype.toString = function() {
      return this.id + ": " + (this.elapsed()) + "ms";
    };

    Benchmark.prototype.print = function() {
      return console.log(this.toString());
    };

    Benchmark.prototype.prettyPrint = function() {
      var elaspsedString;
      elaspsedString = (this.elapsed()) + "ms";
      return console.log((colors.magenta(this.id)) + ": " + (colors.green(elaspsedString)));
    };

    Benchmark.resetIds = function() {
      return global_ids = {};
    };

    return Benchmark;

  })();

  Benchmark.resetIds();

  module.exports = Benchmark;

}).call(this);

//# sourceMappingURL=benchmark.js.map
